import { useCallback } from 'react';
import { isCallback, isDependencies, isOptions } from './generic';
import { useClient } from './use-client';
import { firstOfType } from 'resolve-core';

function useCommand(command, options, callback, dependencies) {
  var _firstOfType;

  var client = useClient();
  var actualOptions = firstOfType(isOptions, options);
  var actualCallback = firstOfType(isCallback, options, callback);
  var actualDependencies = (_firstOfType = firstOfType(isDependencies, options, callback, dependencies)) != null ? _firstOfType : [command, actualOptions, actualCallback].filter(function (i) {
    return i;
  });

  if (typeof command === 'function') {
    return useCallback(function (data) {
      return client.command(command(data), actualOptions, actualCallback);
    }, [client].concat(actualDependencies));
  }

  return useCallback(function () {
    return client.command(command, actualOptions, actualCallback);
  }, [client].concat(actualDependencies));
}

export { useCommand };
//# sourceMappingURL=use-command.js.map