import { Query, QueryOptions, QueryResult, QueryCallback } from 'resolve-client';
import { HookExecutor } from './generic';
export declare type QueryBuilder<T> = (data: T) => Query;
export declare type QueryExecutor<T> = HookExecutor<T, QueryResult>;
declare function useQuery(query: Query): QueryExecutor<void>;
declare function useQuery(query: Query, options: QueryOptions): QueryExecutor<void>;
declare function useQuery(query: Query, callback: QueryCallback): QueryExecutor<void>;
declare function useQuery(query: Query, dependencies: any[]): QueryExecutor<void>;
declare function useQuery(query: Query, callback: QueryCallback, dependencies: any[]): QueryExecutor<void>;
declare function useQuery(query: Query, options: QueryOptions, callback: QueryCallback): QueryExecutor<void>;
declare function useQuery(query: Query, options: QueryOptions, dependencies: any[]): QueryExecutor<void>;
declare function useQuery(query: Query, options: QueryOptions, callback: QueryCallback, dependencies: any[]): QueryExecutor<void>;
declare function useQuery<T>(builder: QueryBuilder<T>): QueryExecutor<T>;
declare function useQuery<T>(builder: QueryBuilder<T>, options: QueryOptions): QueryExecutor<T>;
declare function useQuery<T>(builder: QueryBuilder<T>, callback: QueryCallback): QueryExecutor<T>;
declare function useQuery<T>(builder: QueryBuilder<T>, dependencies: any[]): QueryExecutor<T>;
declare function useQuery<T>(builder: QueryBuilder<T>, callback: QueryCallback, dependencies: any[]): QueryExecutor<T>;
declare function useQuery<T>(builder: QueryBuilder<T>, options: QueryOptions, callback: QueryCallback): QueryExecutor<T>;
declare function useQuery<T>(builder: QueryBuilder<T>, options: QueryOptions, dependencies: any[]): QueryExecutor<T>;
declare function useQuery<T>(builder: QueryBuilder<T>, options: QueryOptions, callback: QueryCallback, dependencies: any[]): QueryExecutor<T>;
export { useQuery };
